clear all


cd "C:\Users\Toshiba\Dropbox\Redoublement"
sysdir set PERSONAL "C:\Users\Toshiba\Dropbox\Redoublement\ado\personal"
sysdir set PLUS "C:\Users\Toshiba\Dropbox\Redoublement\ado\plus"

cd "C:\Users\MAGOU238\Dropbox\Redoublement"
sysdir set PERSONAL "C:\Users\MAGOU238\Dropbox\Redoublement\ado\personal"
sysdir set PLUS "C:\Users\MAGOU238\Dropbox\Redoublement\ado\plus"

use BDD_2012_p0,replace

scalar size=_N


local k = 1
while `k' < 50 {

use BDD_2012_p0,replace
drop  thetam group1-group4

bsample , cluster(ident) idcluster(ident2)

save BDDsample,replace

char cspp[omit] 5
char dipm[omit] 1
char inzep1[omit] 2
char inzep2[omit] 2
char inzep3[omit] 2
char inzep4[omit] 2
char inzep5[omit] 2

/* Iterations until convergence */

set more off
local crit=1
local iter=1
local llk=0

di "Program started on $S_DATE at $S_TIME" 
while `iter'<1000 & `crit'>0.00001 {

quietly{

run Model55.do

gen vrais_indiv=normalden(resm0,0,sigma_resm0)*normalden(resf0,0,sigma_resf0)*normalden(resn1,0,sigma_resn1) /*
*/ *P1^pass1*(1-P1)^(1-pass1) /*
*/ *normalden(resn2,0,sigma_resn2)^(pass1==1)*normalden(resn2r,0,sigma_resn2r)^(pass1==0) /*
*/ *(P20^(pass2==0)*P21^(pass2==1)*P22^(pass2==2))^(pass1==1)*((1-P2r)^(pass2==0)*P2r^(pass2==2))^(pass1==0)  /*
*/ *normalden(resn3,0,sigma_resn3)^(pass2==2 & pass1==1)*normalden(resn3r,0,sigma_resn3r)^((pass2==2 & pass1==0) |(pass2==1 & pass1==1) ) /*
*/ *(P30^(pass3==0)*P31^(pass3==1)*P32^(pass3==2))^(pass2==2 & pass1==1)*((1-P3r)^(pass3==0)*P3r^(pass3==2))^((pass2==2 & pass1==0) |(pass2==1 & pass1==1) ) /*
*/ *normalden(resn4,0,sigma_resn4)^(repet==0)*normalden(resn4r,0,sigma_resn4r)^(repet==1) /*
*/ *P4^(pass4==1)*(1-P4)^(pass4==0) /*
*/ *normalden(resn5,0,sigma_resn5)^(repet==1) /*                            
*/ *normalden(resbrevm_pass,0,sigma_resbrevm_pass)^(repet==0)*normalden(resbrevm_passpas,0,sigma_resbrevm_passpas)^(repet==1) /*
*/ *normalden(resbrevf_pass,0,sigma_resbrevf_pass)^(repet==0)*normalden(resbrevf_passpas,0,sigma_resbrevf_passpas)^(repet==1) 
* *(P2nde^pass2nde*(1-P2nde)^(1-pass2nde))^(repet==0)*(P2nder^pass2nder*(1-P2nder)^(1-pass2nder))^(repet==1)


/* Build the individual weight */

gen weight_vrais=prob1*vrais_indiv
bysort ident2 : egen weight_sum=total(weight_vrais)

gen weight_indiv_prim=prob1*vrais_indiv/weight_sum

/* New type weights using constraints */

bysort group_cat : egen prob_prim=mean(weight_indiv_prim)


/*Calcul de la vraisemblance total*/
gen a=log(weight_sum)/4

gen vrais=sum(a)
su vrais
local llk=r(mean)

gen diff= (prob1-prob_prim)^2 

egen diff_sum_square=sum(diff)

sum diff_sum_square

local crit=r(mean)
local iter=`iter'+1

/* Actualisation of weight */

drop prob1 prob_indiv 
rename prob_prim prob1
rename weight_indiv_prim prob_indiv

drop resm0 resf0 resm02 resf02 resn1 resn12 resn22 resn2 resn3 resn32 resn4 resn42 resn5 resn52 /*
*/ resn22r resn2r resn3r resn32r resn4r resn42r resn5 resn52 P1 P4 P20 P21 P22 P30 P31 P32 P2r P3r /*P2nde P2nder*/ /*
*/ resbrevm_pass resbrevm_passpas resbrevf_pass resbrevf_passpas resbrevm_pass2 resbrevm_passpas2 resbrevf_pass2 resbrevf_passpas2  /*
*/ vrais_indiv weight_sum weight_vrais diff diff_sum_square repett vrais a
}

if mod(`iter',5)==0 {

di "Nb d'iterations =" `iter'

di "Heure : $S_TIME" 

di "crit ="  `crit'

di "Loglikelihood=" `llk'

}

}


/* After convergence : results interpretation */
* Critre BIC  4points(3170802.4) 3points(2181264.7)
gen llk=`llk'



/*************************************************************/
/***********Estimation results with prob_indiv***************/
/***********************************************************/


xi : reg mathel_std i.group_cat  [pweight=prob_indiv]

gen thetam=_b[_cons] if group_cat==1
replace thetam=_b[_cons]+_b[ _Igroup_cat_2] if group_cat==2
replace thetam=_b[_cons]+_b[ _Igroup_cat_3] if group_cat==3
replace thetam=_b[_cons]+_b[ _Igroup_cat_4] if group_cat==4

di thetam[1]

if thetam[1]<35.5 {

drop group_cat

tab thetam, gen(group)
label var group2 "Group 2"
label var group3 "Group 3"
label var group4 "Group 4"

gen group_cat=1*(group1)+2*(group2)+3*(group3)+4*(group4)

gen repett=0

/*Math and French score before the entrance to grade 6 */
/*Prediction du capital humain*/

xi : reg mathel_std group2-group4  [pweight=prob_indiv]
mat b=e(b)
svmat b,names(eqcol)

outsheet _group2-__cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regm0_`k'.out", nolabel nonames replace
drop _group2-__cons

xi : reg franel_std group2-group4  [pweight=prob_indiv]

mat b=e(b)
svmat b,names(eqcol)

outsheet _group2-__cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regf0_`k'.out", nolabel nonames replace
drop _group2-__cons

/*Size of class*/

xi : reg ned1 ned1_th secteur1  eff_etab_t1 tuetab12-tuetab19 net1_tr2-net1_tr3 lv11_all inzep1 /* 
*/ group2-group4 [pweight=prob_indiv]
mat b=e(b)
svmat b,names(eqcol)

outsheet _ned1_th-__cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regn1_`k'.out", nolabel nonames replace
drop _ned1_th-__cons

xi : oprobit pass1 ned1 secteur1 lv11_all inzep1 group2-group4   [pweight=prob_indiv]
predict P1
mat b=e(b)
svmat b,names(eqcol)

outsheet pass1ned1-cut1_cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regp1_`k'.out", nolabel nonames  replace
drop pass1ned1-cut1_cons

replace repett=1 if pass1==0

xi : reg ned2 ned2_th secteur2 eff_etab_t2 tuetab22-tuetab29 lv12_all lv12_othe inzep2 /* 
*/ group2-group4  [pweight=prob_indiv] if repett==0
predict n2contrefact if repett==1
replace n2contrefact=n2contrefact+_b[ned2_th]*(ned2_th_c-ned2_th)
mat b=e(b)
matname b group4, col(17)
svmat b,names(eqcol)

outsheet _ned2_th-__cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regn2_`k'.out", nolabel nonames replace
drop _ned2_th-__cons

xi : reg ned2 ned2_th tuetab28 tuetab29 net2_tr3 lv12_all inzep2 group2-group4  [pweight=prob_indiv] if repett==1
predict n2Rcontrefact if repett==0
replace n2Rcontrefact= n2Rcontrefact+_b[ned2_th]*(ned2_th_c-ned2_th) 
mat b=e(b)
matname b group4, col(9)
svmat b,names(eqcol)

outsheet _ned2_th-__cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regn2r_`k'.out", nolabel nonames  replace
drop _ned2_th-__cons

xi : oprobit pass2 ned2 tuetab28 tuetab29 net2_tr3 lv12_all inzep2 /* 
*/ group2-group4   [pweight=prob_indiv] if pass1==1
predict P20 P21 P22 if repett==0
predict P2xb if repett==1, xb 
replace P2xb=P2xb+_b[ned2]*(n2contrefact-ned2)
gen P20contrefact=normprob(_b[/cut1]-P2xb)
gen P21contrefact=normprob(_b[/cut2]-P2xb)-normprob(_b[/cut1]-P2xb)
gen P22contrefact=normprob(P2xb-_b[/cut2])
mat b=e(b)
matname b group4, col(9) 
svmat b,names(eqcol)

outsheet pass2ned2-cut2_cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regp2_`k'.out", nolabel nonames replace
drop pass2ned2-cut2_cons

xi : oprobit pass2 ned2 tuetab23 tuetab26 tuetab27 tuetab29 net2_tr3  /* 
*/ group2-group4 [pweight=prob_indiv] if repett==1
predict P2r if repett==1,outcome(2)
predict P2xbr if repett==0, xb
replace P2xbr=P2xbr+_b[ned2]*(n2Rcontrefact-ned2)
gen P2Rcontrefact=normprob(P2xbr-_b[/cut1])
mat b=e(b)
matname b group4, col(9)
svmat b,names(eqcol)

outsheet pass2ned2-cut1_cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regp2r_`k'.out", nolabel nonames replace
drop pass2ned2-cut1_cons

replace repett=1 if pass2==1
replace repett=. if pass2==0

xi : reg ned3 ned3_th  secteur3 eff_etab_t3 tuetab32-tuetab39 net3_tr2 lv13_all inzep3 /* 
*/ group2-group4  [pweight=prob_indiv] if repett==0
predict n3contrefact if repett==1
replace n3contrefact=n3contrefact+_b[ned3_th]*(ned3_th_cr-ned3_th)
replace n3contrefact= _b[ned3_th]*ned3_th_cr+_b[secteur3]*secteur2+_b[eff_etab_t3]*eff_etab_t3_c+_b[tuetab32]*tuetab22+_b[tuetab33]*tuetab23 /*
*/ +_b[tuetab34]*tuetab24+_b[tuetab35]*tuetab25 +_b[tuetab36]*tuetab26+_b[tuetab37]*tuetab27+_b[tuetab38]*tuetab28 +_b[tuetab39]*tuetab29/*
*/ +_b[net3_tr2]*net2_tr2+_b[lv13_all]*lv12_all+_b[inzep3]*inzep2+_b[group2]*group2+_b[group3]*group3+_b[group4]*group4+_b[_cons]  if repett==. 
mat b=e(b)
svmat b,names(eqcol)

outsheet _ned3_th-__cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regn3_`k'.out", nolabel nonames  replace
drop _ned3_th-__cons

xi : reg ned3 ned3_th  secteur3 eff_etab_t3 tuetab33 tuetab39 net3_tr3 lv13_all inzep3 /* 
*/ group2-group4  [pweight=prob_indiv] if repett==1
predict n3Rcontrefact if repett==0 
replace n3Rcontrefact= n3Rcontrefact+_b[ned3_th]*(ned3_th_c-ned3_th)
replace n3Rcontrefact= _b[ned3_th]*ned3_th_c+_b[secteur3]*secteur2+_b[eff_etab_t3]*eff_etab_t3_c+_b[tuetab33]*tuetab23+_b[tuetab39]*tuetab29 /*
*/ +_b[net3_tr3]*net2_tr3+_b[lv13_all]*lv12_all+_b[inzep3]*inzep2+_b[group2]*group2+_b[group3]*group3+_b[group4]*group4+_b[_cons]  if repett==. 
mat b=e(b)
svmat b,names(eqcol)

outsheet _ned3_th-__cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regn3r_`k'.out", nolabel nonames replace
drop  _ned3_th-__cons

xi : oprobit pass3 ned3 eff_etab_t3 tuetab33 tuetab34 net3_tr3 lv13_all  /* 
*/ group2-group4   [pweight=prob_indiv] if repett==0
predict P30 P31 P32 if repett==0
predict P3xb if repett==1, xb 
replace P3xb=P3xb+_b[ned3]*(n3contrefact-ned3)
replace P3xb= _b[ned3]*n3contrefact+_b[eff_etab_t3]*eff_etab_t3_c+_b[tuetab33]*tuetab23+_b[tuetab34]*tuetab24+_b[net3_tr3]*net2_tr3+_b[lv13_all]*lv12_all+_b[group2]*group2 /*
*/ +_b[group3]*group4 if repett==.
gen P30contrefact=normprob(_b[/cut1]-P3xb)
gen P31contrefact=normprob(_b[/cut2]-P3xb)-normprob(_b[/cut1]-P3xb)
gen P32contrefact=normprob(P3xb-_b[/cut2])
mat b=e(b)
svmat b,names(eqcol)

outsheet pass3ned3-cut2_cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regp3_`k'.out", nolabel nonames  replace
drop pass3ned3-cut2_cons

xi : oprobit pass3 ned3 tuetab39 net3_tr2-net3_tr3 lv13_all   /* 
*/ group2-group4  [pweight=prob_indiv] if repett==1
predict P3r if repett==1,outcome(2)
predict P3xbr if repett==0, xb
replace P3xbr=P3xbr+_b[ned3]*(n3Rcontrefact-ned3)
replace P3xbr=_b[ned3]*n3Rcontrefact+_b[tuetab39]*tuetab29+_b[net3_tr2]*net2_tr2+_b[net3_tr3]*net2_tr3+_b[lv13_all]*lv12_all+_b[group2]*group2 /*
*/ +_b[group3]*group4 if repett==.
gen P3Rcontrefact=normprob(P3xbr-_b[/cut1])
mat b=e(b)
svmat b,names(eqcol)


outsheet pass3ned3-cut1_cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regp3r_`k'.out", nolabel nonames replace
drop pass3ned3-cut1_cons

replace repett=1 if pass3==1
replace repett=. if pass3==0

xi : reg ned4 ned4_th secteur4 eff_etab_t4 tuetab42-tuetab49 lv14_all inzep4 /* 
*/  group2-group4  [pweight=prob_indiv]  if repett==0
predict n4contrefact if repett==1
replace n4contrefact=n4contrefact+_b[ned4_th]*(ned4_th_cr-ned4_th) 
replace n4contrefact=_b[ned4_th]*ned4_th_cr+_b[secteur4]*secteur2+_b[eff_etab_t4]*eff_etab_t4_c+_b[tuetab42]*tuetab22+_b[tuetab43]*tuetab23/*
*/+_b[tuetab44]*tuetab24+_b[tuetab45]*tuetab25+_b[tuetab46]*tuetab26+_b[tuetab47]*tuetab27+_b[tuetab48]*tuetab28+_b[tuetab49]*tuetab29  /*
*/+_b[lv14_all]*lv12_all+_b[inzep4]*inzep2+_b[group2]*group2+_b[group3]*group3+_b[group4]*group4+_b[_cons] if repett==.
mat b=e(b)
svmat b,names(eqcol)

outsheet _ned4_th-__cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regn4_`k'.out", nolabel nonames replace
drop _ned4_th-__cons

xi : reg ned4 ned4_th secteur4  eff_etab_t4 tuetab42-tuetab44 tuetab46 tuetab48-tuetab49 lv14_all inzep4 /* 
*/  group2-group4  [pweight=prob_indiv]  if repett==1
predict n4Rcontrefact if repett==0
replace n4Rcontrefact=n4Rcontrefact+_b[ned4_th]*(ned4_th_c-ned4_th) 
replace n4Rcontrefact=_b[ned4_th]*ned4_th_c+_b[secteur4]*secteur2+_b[eff_etab_t4]*eff_etab_t4_c+_b[tuetab42]*tuetab22+_b[tuetab43]*tuetab23/*
*/+_b[tuetab44]*tuetab24+_b[tuetab46]*tuetab26+_b[tuetab48]*tuetab28+_b[tuetab49]*tuetab29  /*
*/+_b[lv14_all]*lv12_all+_b[inzep4]*inzep2+_b[group2]*group2+_b[group3]*group3+_b[group4]*group4+_b[_cons] if repett==.
mat b=e(b)
svmat b,names(eqcol)

outsheet _ned4_th-__cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regn4r_`k'.out", nolabel nonames  replace
drop _ned4_th-__cons

xi : oprobit pass4 ned4 secteur4 tuetab43 tuetab44 tuetab46 tuetab48 tuetab49  /* 
*/ group2-group4  [pweight=prob_indiv] if repett==1
predict P4r if repett==1,outcome(1)
predict P4xbr if repett==0, xb
replace P4xbr=P4xbr+_b[ned4]*(n4Rcontrefact-ned4)
replace P4xbr=_b[ned4]*n4Rcontrefact+_b[tuetab43]*tuetab23+_b[tuetab44]*tuetab24+_b[tuetab46]*tuetab26+_b[tuetab48]*tuetab28+_b[tuetab49]*tuetab29 /*
*/ +_b[group2]*group2+_b[group3]*group4 if repett==.
gen P4Rcontrefact=normprob(P4xbr-_b[/cut1])
mat b=e(b)
svmat b,names(eqcol)

outsheet pass4ned4-cut1_cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regp4r_`k'.out", nolabel nonames  replace
drop pass4ned4-cut1_cons

replace repett=. if pass4==0

xi : reg ned5 ned5_th eff_etab_t5 tuetab52 tuetab56-tuetab59 net5_tr4 lv15_all inzep5 /* 
*/ group2-group4 [pweight=prob_indiv] if repet==1
gen n5contrefact=_b[_cons]+_b[ned5_th]*ned5_th_c+_b[eff_etab_t5]*eff_etab_t4 +_b[tuetab52]*(tuetab4=="1")+_b[tuetab56]*(tuetab4=="5")+_b[tuetab57]*(tuetab4=="6") /*
*/+_b[tuetab58]*(tuetab4=="7")+_b[tuetab59]*(tuetab4=="8") /*
*/+_b[net5_tr4]*(net4_tr==3)+_b[lv15_all]*lv14_all /*
*/+_b[inzep5]*inzep4+_b[group2]*group2+_b[group3]*group3+_b[group4]*group4 if repet==0
mat b=e(b)
svmat b,names(eqcol)

outsheet _ned5_th-__cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regn5r_`k'.out", nolabel nonames replace
drop _ned5_th-__cons

xi : reg grade9_mat_std ned4 secteur4 tuetab45 tuetab47 net4_tr4 lv14_all inzep4 /* 
*/  group2-group4  [pweight=prob_indiv] if repet==0
predict grade9m_ifpass if repet==1
replace grade9m_ifpass=grade9m_ifpass+_b[ned4]*(n4contrefact-ned4) if repet==1
mat b=e(b)
svmat b,names(eqcol)

outsheet _ned4-__cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regm9_`k'.out", nolabel nonames replace
drop _ned4-__cons

xi : reg grade9_fra_std ned4 tuetab46 lv14_all inzep4 /* 
*/ group2-group4  [pweight=prob_indiv] if repet==0
predict grade9f_ifpass if repet==1
replace grade9f_ifpass=grade9f_ifpass+_b[ned4]*(n4contrefact-ned4) if repet==1
mat b=e(b)
svmat b,names(eqcol)

outsheet _ned4-__cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regf9_`k'.out", nolabel nonames replace
drop _ned4-__cons

/* Student who did a retention but are in the general field */

xi : reg grade9_mat_std ned5 secteur5 tuetab57 tuetab59 net5_tr4 group2-group4  [pweight=prob_indiv] if repet==1
gen grade9m_ifpasspas =_b[_cons]+_b[ned5]*n5contrefact+_b[secteur5]*(secteur4==1)+_b[tuetab57]*(tuetab4=="6")+_b[tuetab59]*(tuetab4=="8") /*
*/+_b[net5_tr4]*(net4_tr==3)+_b[group2]*group2+_b[group3]*group3+_b[group4]*group4 if repet==0
mat b=e(b)
svmat b,names(eqcol)

outsheet _ned5-__cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regm9r_`k'.out", nolabel nonames  replace
drop _ned5-__cons

xi : reg grade9_fra_std ned5 secteur5 tuetab54  /* 
*/ group2-group4  [pweight=prob_indiv] if repet==1
gen grade9f_ifpasspas =_b[_cons]+_b[ned5]*n5contrefact +_b[secteur5]*(secteur4==1)+_b[tuetab54]*(tuetab4=="3") /*
*/+_b[group2]*group2+_b[group3]*group3+_b[group4]*group4 if repet==0
mat b=e(b)
svmat b,names(eqcol)

outsheet _ned5-__cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regf9r_`k'.out", nolabel nonames  replace
drop _ned5-__cons

/*
xi : oprobit pass2nde ned4 tuetab43 tuetab45-tuetab48 net4_tr2 lv14_all inzep4  /* 
*/ i.group_cat [pweight=prob_indiv] if repet==0
predict XB if repet==1, xb 
replace XB=XB+_b[ned4]*(n4contrefact-ned4) if repet==1
gen P2ndecontrefact=normal(_b[/cut1]-XB) if repet==1 /*P=normal(_b[/cut1]-xb)*/
drop XB
mat b=e(b)
svmat b,names(eqcol)

outsheet pass2ndened4-cut1_cons using "C:\Users\Toshiba\Dropbox\Redoublement\regp2nde_`k'.out", nolabel nonames  replace
drop pass2ndened4-cut1_cons

xi : oprobit pass2nder ned5 tuetab55 tuetab57-tuetab59 i.secteur5 lv15_othe /* 
*/ group2-group4 [pweight=prob_indiv] if repet==1
gen XB=_b[ned5]*n5contrefact+_b[_Isecteur5_1]*(secteur4==1) +_b[tuetab55]*(tuetab4=="4")+_b[tuetab55]*(tuetab4=="6")+_b[tuetab55]*(tuetab4=="7")+_b[tuetab59]*(tuetab4=="8") /*
*/+_b[lv15_othe]*lv14_othe+_b[group2]*group2+_b[group3]*group3+_b[group4]*group4 if repet==0
gen P2rndecontrefact=normal(_b[/cut1]-XB) if repet==0 /*P=normal(_b[/cut1]-xb)*/
drop XB
mat b=e(b)
svmat b,names(eqcol)

outsheet pass2nderned5-cut1_cons using "C:\Users\Toshiba\Dropbox\Redoublement\regp2nder_`k'.out", nolabel nonames  replace
drop pass2nderned5-cut1_cons
*/

* Proba to reach grade 9  /*  P1*P22*P32 + P1*P22*P31*P4r + P1*P21*P3r*P4r + (1-P1)*P2r*P3r*P4r  */
gen Select= P1*P22*P32 + P1*P22*P31*P4Rcontrefact + P1*P21*P3Rcontrefact*P4Rcontrefact + (1-P1)*P2Rcontrefact*P3Rcontrefact*P4Rcontrefact if voie1234
replace Select=P1*P22*P32 + P1*P22*P31*P4r + P1*P21*P3Rcontrefact*P4r + (1-P1)*P2Rcontrefact*P3Rcontrefact*P4r  if voie12334 | voie1233V
replace Select=P1*P22*P32contrefact + P1*P22*P31contrefact*P4r + P1*P21*P3r*P4r + (1-P1)*P2Rcontrefact*P3r*P4r  if voie12234 | voie1223V
replace Select=P1*P22contrefact*P32contrefact + P1*P22contrefact*P31contrefact*P4r + P1*P21contrefact*P3r*P4r + (1-P1)*P2r*P3r*P4r  if voie11234 | voie1123V
replace Select=P1*P22*P32 + P1*P22*P31*P4Rcontrefact + P1*P21*P3Rcontrefact*P4Rcontrefact + (1-P1)*P2Rcontrefact*P3Rcontrefact*P4Rcontrefact if voie123V 
replace Select=P1*P22*P32contrefact + P1*P22*P31contrefact*P4Rcontrefact + P1*P21*P3r*P4Rcontrefact + (1-P1)*P2Rcontrefact*P3r*P4Rcontrefact if voie122V 
replace Select=P1*P22contrefact*P32contrefact + P1*P22contrefact*P31contrefact*P4Rcontrefact + P1*P21contrefact*P3r*P4Rcontrefact + (1-P1)*P2r*P3r*P4Rcontrefact if voie112V 
replace Select=P1*P22*P32contrefact + P1*P22*P31contrefact*P4Rcontrefact + P1*P21*P3Rcontrefact*P4Rcontrefact + (1-P1)*P2Rcontrefact*P3Rcontrefact*P4Rcontrefact if voie12V 
replace Select=P1*P22contrefact*P32contrefact + P1*P22contrefact*P31contrefact*P4Rcontrefact + P1*P21contrefact*P3Rcontrefact*P4Rcontrefact + (1-P1)*P2r*P3Rcontrefact*P4Rcontrefact if voie11V 

* Proba to reach grade 9 if grade retention is forbidden /*  (P21+P22)*(P31+P32) */
gen Select2= (P21+P22)*(P31+P32) if voie1234 | voie12334 | voie1233V | voie123V 
replace Select2=  (P21+P22)*(P31contrefact+P32contrefact) if voie12234 | voie1223V | voie122V | voie12V
replace Select2= (P21contrefact+P22contrefact)*(P31contrefact+P32contrefact) if voie11234 | voie1123V | voie112V | voie11V

gen Effect_sel=Select2-Select
* Calcul des ATE et ATT

gen Effectm=(grade9m_ifpasspas-grade9_mat_std) if repet==0
replace Effectm=(grade9_mat_std-grade9m_ifpass) if repet==1

gen Effectf=(grade9f_ifpasspas-grade9_fra_std) if repet==0
replace Effectf=(grade9_fra_std-grade9f_ifpass) if repet==1

/*
replace pass2nde=. if pass2nde==-1
replace pass2nder=. if pass2nder==-1

gen Effect2nde=(P2rndecontrefact-pass2nde) if repet==0
replace  Effect2nde=(pass2nder-P2ndecontrefact) if repet==1
*/

* ATE
estpost sum Effectm Effectf Effect_sel [weight=prob_indiv]
estout using "C:\Users\MAGOU238\Dropbox\Redoublement\ATE_`k'.out",replace cells("count sum_w mean")

tabexport Effectm Effectf Effect_sel [weight=prob_indiv] using "C:\Users\MAGOU238\Dropbox\Redoublement\ATE2_`k'.out", s(mean) by(group_cat) replace

* ATT
estpost sum Effectm Effectf Effect_sel [weight=prob_indiv] if repet==1
estout using "C:\Users\MAGOU238\Dropbox\Redoublement\ATT_`k'.out",replace cells("count sum_w mean")

tabexport Effectm Effectf Effect_sel [weight=prob_indiv] using "C:\Users\MAGOU238\Dropbox\Redoublement\ATT2_`k'.out" if repet==1, s(mean) by(group_cat) replace

* Support et llk
collapse (mean) thetam prob1 llk , by(group_cat)
outsheet thetam prob1 using "C:\Users\MAGOU238\Dropbox\Redoublement\Bootstrap_`k'.out", nolabel nonames replace

local k = `k' + 1
}
}



