clear all


cd "C:\Users\Toshiba\Dropbox\Redoublement"
sysdir set PERSONAL "C:\Users\Toshiba\Dropbox\Redoublement\ado\personal"
sysdir set PLUS "C:\Users\Toshiba\Dropbox\Redoublement\ado\plus"

cd "C:\Users\MAGOU238\Dropbox\Redoublement"
sysdir set PERSONAL "C:\Users\MAGOU238\Dropbox\Redoublement\ado\personal"
sysdir set PLUS "C:\Users\MAGOU238\Dropbox\Redoublement\ado\plus"

use BDD_2012_p0X,replace

scalar size=_N


local k = 1
while `k' < 50 {

use BDD_2012_p0X,replace
drop  thetam group1-group4

bsample , cluster(ident) idcluster(ident2)

save BDDsample,replace

char cspp[omit] 5
char dipm[omit] 1
char inzep1[omit] 2
char inzep2[omit] 2
char inzep3[omit] 2
char inzep4[omit] 2
char inzep5[omit] 2

/* Iterations until convergence */

set more off
local crit=1
local iter=1
local llk=0

di "Program started on $S_DATE at $S_TIME" 
while `iter'<1000 & `crit'>0.00001 {

quietly{

run Model55X.do

gen vrais_indiv=normalden(resm0,0,sigma_resm0)*normalden(resf0,0,sigma_resf0)*normalden(resn1,0,sigma_resn1) /*
*/ *P1^pass1*(1-P1)^(1-pass1) /*
*/ *normalden(resn2,0,sigma_resn2)^(pass1==1)*normalden(resn2r,0,sigma_resn2r)^(pass1==0) /*
*/ *(P20^(pass2==0)*P21^(pass2==1)*P22^(pass2==2))^(pass1==1)*((1-P2r)^(pass2==0)*P2r^(pass2==2))^(pass1==0)  /*
*/ *normalden(resn3,0,sigma_resn3)^(pass2==2 & pass1==1)*normalden(resn3r,0,sigma_resn3r)^((pass2==2 & pass1==0) |(pass2==1 & pass1==1) ) /*
*/ *(P30^(pass3==0)*P31^(pass3==1)*P32^(pass3==2))^(pass2==2 & pass1==1)*((1-P3r)^(pass3==0)*P3r^(pass3==2))^((pass2==2 & pass1==0) |(pass2==1 & pass1==1) ) /*
*/ *normalden(resn4,0,sigma_resn4)^(repet==0)*normalden(resn4r,0,sigma_resn4r)^(repet==1) /*
*/ *P4^(pass4==1)*(1-P4)^(pass4==0) /*
*/ *normalden(resn5,0,sigma_resn5)^(repet==1) /*                            
*/ *normalden(resbrevm_pass,0,sigma_resbrevm_pass)^(repet==0)*normalden(resbrevm_passpas,0,sigma_resbrevm_passpas)^(repet==1) /*
*/ *normalden(resbrevf_pass,0,sigma_resbrevf_pass)^(repet==0)*normalden(resbrevf_passpas,0,sigma_resbrevf_passpas)^(repet==1) 


/* Build the individual weight */

gen weight_vrais=prob1*vrais_indiv
bysort ident2 : egen weight_sum=total(weight_vrais)

gen weight_indiv_prim=prob1*vrais_indiv/weight_sum

/* New type weights using constraints */

bysort group_cat : egen prob_prim=mean(weight_indiv_prim)

/*Calcul de la vraisemblance total*/
gen a=log(weight_sum)/4

gen vrais=sum(a)
su vrais
local llk=r(mean)

gen diff= (prob1-prob_prim)^2 

egen diff_sum_square=sum(diff)

sum diff_sum_square

local crit=r(mean)
local iter=`iter'+1

/* Actualisation of weight */

drop prob1 prob_indiv 
rename prob_prim prob1
rename weight_indiv_prim prob_indiv

drop resm0 resf0 resm02 resf02 resn1 resn12 resn22 resn2 resn3 resn32 resn4 resn42 resn5 resn52 /*
*/ resn22r resn2r resn3r resn32r resn4r resn42r resn5 resn52 P1 P4 P20 P21 P22 P30 P31 P32 P2r P3r /*P2nde P2nder*/ /*
*/ resbrevm_pass resbrevm_passpas resbrevf_pass resbrevf_passpas resbrevm_pass2 resbrevm_passpas2 resbrevf_pass2 resbrevf_passpas2  /*
*/ vrais_indiv weight_sum weight_vrais diff diff_sum_square repett vrais a
}

if mod(`iter',5)==0 {

di "Nb d'iterations =" `iter'

di "Heure : $S_TIME" 

di "crit ="  `crit'

di "Loglikelihood=" `llk'

}

}


/* After convergence : results interpretation */
* Critre BIC  4points(3170802.4) 3points(2181264.7)
gen llk=`llk'

/*************************************************************/
/***********Estimation results with prob_indiv***************/
/***********************************************************/


xi : reg mathel_std i.group_cat  [pweight=prob_indiv]

gen thetam=_b[_cons] if group_cat==1
replace thetam=_b[_cons]+_b[ _Igroup_cat_2] if group_cat==2
replace thetam=_b[_cons]+_b[ _Igroup_cat_3] if group_cat==3
replace thetam=_b[_cons]+_b[ _Igroup_cat_4] if group_cat==4

di thetam[1]


drop group_cat

tab thetam, gen(group)
label var group2 "Group 2"
label var group3 "Group 3"
label var group4 "Group 4"

gen group_cat=1*(group1)+2*(group2)+3*(group3)+4*(group4)

gen repett=0

/*Math and French score before the entrance to grade 6 */
/*Prediction du capital humain*/

xi : reg mathel_std femme cspp3 dipm6 redoub_prim group2-group4  [pweight=prob_indiv]
mat b=e(b)
svmat b,names(eqcol)

outsheet _group2-__cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regm0_`k'.out", nolabel nonames replace
drop _femme-__cons

xi : reg franel_std femme cspp3 dipm6 redoub_prim group2-group4  [pweight=prob_indiv]
mat b=e(b)
svmat b,names(eqcol)

outsheet _group2-__cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regf0_`k'.out", nolabel nonames replace
drop _femme-__cons

/*Size of class*/
xi : reg ned1 ned1_th femme cspp3 dipm6 redoub_prim secteur1  eff_etab_t1 tuetab12-tuetab19 net1_tr2-net1_tr3 lv11_all inzep1 /* 
*/ group2-group4 [pweight=prob_indiv]
mat b=e(b)
svmat b,names(eqcol)

outsheet _ned1_th-__cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regn1_`k'.out", nolabel nonames replace
drop _ned1_th-__cons


xi : oprobit pass1 ned1 i.quarter femme cspp3 dipm6 redoub_prim eff_etab_t1 i.secteur1 lv11_all inzep1 /*
*/ i.group_cat [pweight=prob_indiv] 
mat b=e(b)
svmat b,names(eqcol)

outsheet pass1ned1-cut1_cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regp1_`k'.out", nolabel nonames  replace
drop pass1ned1-cut1_cons

replace repett=1 if pass1==0

xi : oprobit pass2 ned2 i.quarter femme cspp3 dipm6 redoub_prim tuetab28 tuetab29 net2_tr3 lv12_all inzep2 /* 
*/ i.group_cat   [pweight=prob_indiv] if pass1==1
mat b=e(b)
matname b group4, col(9) 
svmat b,names(eqcol)

outsheet pass2ned2-cut2_cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regp2_`k'.out", nolabel nonames replace
drop pass2ned2-cut2_cons

xi : oprobit pass2 ned2 i.quarter femme cspp3 dipm6 redoub_prim tuetab23 tuetab26 tuetab27 tuetab29 net2_tr3  /* 
*/ i.group_cat [pweight=prob_indiv] if repett==1
mat b=e(b)
matname b group4, col(9)
svmat b,names(eqcol)

outsheet pass2ned2-cut1_cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regp2r_`k'.out", nolabel nonames replace
drop pass2ned2-cut1_cons

replace repett=1 if pass2==1
replace repett=. if pass2==0

xi : oprobit pass3 ned3 i.quarter femme cspp3 dipm6 redoub_prim eff_etab_t3 tuetab33 tuetab34 net3_tr3 lv13_all  /* 
*/ i.group_cat   [pweight=prob_indiv] if repett==0
mat b=e(b)
svmat b,names(eqcol)

outsheet pass3ned3-cut2_cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regp3_`k'.out", nolabel nonames  replace
drop pass3ned3-cut2_cons

xi : oprobit pass3 ned3 i.quarter femme cspp3 dipm6 redoub_prim tuetab39 net3_tr2-net3_tr3 lv13_all   /* 
*/ i.group_cat  [pweight=prob_indiv] if repett==1
mat b=e(b)
svmat b,names(eqcol)


outsheet pass3ned3-cut1_cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regp3r_`k'.out", nolabel nonames replace
drop pass3ned3-cut1_cons

replace repett=1 if pass3==1
replace repett=. if pass3==0

xi : reg ned4 ned4_th femme cspp3 dipm6 redoub_prim secteur4 eff_etab_t4 tuetab42-tuetab49 lv14_all inzep4 /* 
*/  group2-group4  [pweight=prob_indiv]  if repett==0
predict n4contrefact if repett==1
replace n4contrefact=n4contrefact+_b[ned4_th]*(ned4_th_cr-ned4_th) 
mat b=e(b)
svmat b,names(eqcol)

outsheet _ned4_th-__cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regn4_`k'.out", nolabel nonames replace
drop _ned4_th-__cons

xi : reg ned4 ned4_th femme cspp3 dipm6 redoub_prim secteur4  eff_etab_t4 tuetab42-tuetab44 tuetab46 tuetab48-tuetab49 lv14_all inzep4 /* 
*/  group2-group4  [pweight=prob_indiv]  if repett==1
predict n4Rcontrefact if repett==0
replace n4Rcontrefact=n4Rcontrefact+_b[ned4_th]*(ned4_th_c-ned4_th) 
mat b=e(b)
svmat b,names(eqcol)

outsheet _ned4_th-__cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regn4r_`k'.out", nolabel nonames  replace
drop _ned4_th-__cons

xi : oprobit pass4 ned4 i.quarter femme cspp3 dipm6 redoub_prim secteur4 tuetab43 tuetab44 tuetab46 tuetab48 tuetab49  /* 
*/ i.group_cat  [pweight=prob_indiv] if repett==1
mat b=e(b)
svmat b,names(eqcol)

outsheet pass4ned4-cut1_cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regp4r_`k'.out", nolabel nonames  replace
drop pass4ned4-cut1_cons


replace repett=. if pass4==0

xi : reg ned5 ned5_th femme cspp3 dipm6 redoub_prim eff_etab_t5 tuetab52 tuetab56-tuetab59 net5_tr4 lv15_all inzep5 /* 
*/ group2-group4 [pweight=prob_indiv] if repet==1
gen n5contrefact=_b[_cons]+_b[ned5_th]*ned5_th_c+_b[femme]*femme+_b[cspp3]*cspp3+_b[dipm6]*dipm6+_b[redoub_prim]*redoub_prim +_b[eff_etab_t5]*eff_etab_t4 +_b[tuetab52]*(tuetab4=="1")+_b[tuetab56]*(tuetab4=="5")+_b[tuetab57]*(tuetab4=="6") /*
*/+_b[tuetab58]*(tuetab4=="7")+_b[tuetab59]*(tuetab4=="8") /*
*/+_b[net5_tr4]*(net4_tr==3)+_b[lv15_all]*lv14_all /*
*/+_b[inzep5]*inzep4+_b[group2]*group2+_b[group3]*group3+_b[group4]*group4 if repet==0
mat b=e(b)
svmat b,names(eqcol)

outsheet _ned5_th-__cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regn5r_`k'.out", nolabel nonames replace
drop _ned5_th-__cons

xi : reg grade9_mat_std ned4 femme cspp3 dipm6 redoub_prim secteur4 tuetab45 tuetab47 net4_tr4 lv14_all inzep4 /* 
*/  group2-group4  [pweight=prob_indiv] if repet==0
predict grade9m_ifpass if repet==1
replace grade9m_ifpass=grade9m_ifpass+_b[ned4]*(n4contrefact-ned4) if repet==1
mat b=e(b)
svmat b,names(eqcol)

outsheet _ned4-__cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regm9_`k'.out", nolabel nonames replace
drop _ned4-__cons

xi : reg grade9_fra_std ned4 femme cspp3 dipm6 redoub_prim tuetab46 lv14_all inzep4 /* 
*/ group2-group4  [pweight=prob_indiv] if repet==0
predict grade9f_ifpass if repet==1
replace grade9f_ifpass=grade9f_ifpass+_b[ned4]*(n4contrefact-ned4) if repet==1
mat b=e(b)
svmat b,names(eqcol)

outsheet _ned4-__cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regf9_`k'.out", nolabel nonames replace
drop _ned4-__cons

/* Student who did a retention but are in the general field */

xi : reg grade9_mat_std ned5 femme cspp3 dipm6 redoub_prim secteur5 tuetab57 tuetab59 net5_tr4 group2-group4  [pweight=prob_indiv] if repet==1
gen grade9m_ifpasspas =_b[_cons]+_b[ned5]*n5contrefact+_b[femme]*femme+_b[cspp3]*cspp3+_b[dipm6]*dipm6+_b[redoub_prim]*redoub_prim +_b[secteur5]*(secteur4==1)+_b[tuetab57]*(tuetab4=="6")+_b[tuetab59]*(tuetab4=="8") /*
*/+_b[net5_tr4]*(net4_tr==3)+_b[group2]*group2+_b[group3]*group3+_b[group4]*group4 if repet==0
mat b=e(b)
svmat b,names(eqcol)

outsheet _ned5-__cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regm9r_`k'.out", nolabel nonames  replace
drop _ned5-__cons

xi : reg grade9_fra_std ned5 femme cspp3 dipm6 redoub_prim secteur5 tuetab54  /* 
*/ group2-group4  [pweight=prob_indiv] if repet==1
gen grade9f_ifpasspas =_b[_cons]+_b[ned5]*n5contrefact+_b[femme]*femme+_b[cspp3]*cspp3+_b[dipm6]*dipm6+_b[redoub_prim]*redoub_prim  +_b[secteur5]*(secteur4==1)+_b[tuetab54]*(tuetab4=="3") /*
*/+_b[group2]*group2+_b[group3]*group3+_b[group4]*group4 if repet==0
mat b=e(b)
svmat b,names(eqcol)

outsheet _ned5-__cons using "C:\Users\MAGOU238\Dropbox\Redoublement\regf9r_`k'.out", nolabel nonames  replace
drop _ned5-__cons


* Calcul des ATE et ATT

gen Effectm=(grade9m_ifpasspas-grade9_mat_std) if repet==0
replace Effectm=(grade9_mat_std-grade9m_ifpass) if repet==1

gen Effectf=(grade9f_ifpasspas-grade9_fra_std) if repet==0
replace Effectf=(grade9_fra_std-grade9f_ifpass) if repet==1


* ATE
estpost sum Effectm Effectf  [weight=prob_indiv]
estout using "C:\Users\MAGOU238\Dropbox\Redoublement\ATE_`k'.out",replace cells("count sum_w mean")

tabexport Effectm Effectf [weight=prob_indiv] using "C:\Users\MAGOU238\Dropbox\Redoublement\ATE2_`k'.out", s(mean) by(group_cat) replace

* ATT
estpost sum Effectm Effectf  [weight=prob_indiv] if repet==1
estout using "C:\Users\MAGOU238\Dropbox\Redoublement\ATT_`k'.out",replace cells("count sum_w mean")

tabexport Effectm Effectf [weight=prob_indiv] using "C:\Users\MAGOU238\Dropbox\Redoublement\ATT2_`k'.out" if repet==1, s(mean) by(group_cat) replace

* Support et llk
collapse (mean) thetam prob1 llk , by(group_cat)
outsheet thetam prob1 using "C:\Users\MAGOU238\Dropbox\Redoublement\Bootstrap_`k'.out", nolabel nonames replace

local k = `k' + 1
}




