% Valeurs support VI boucle gnrale
thetam=zeros(1,4);
prob=zeros(1,4);
prob2=zeros(1,4);

% Nb de boucles

l=8

for i=1:l
 
data=load(sprintf('VI_%d.out',i));

thetam(i,:)=data(:,1)';
prob(i,:)=data(:,2)';
llk(i)=data(1,3);
p(i,1)=data(1,4);
p(i,2)=data(1,5);
p(i,3)=data(1,6);
p(i,4)=data(1,7);

end

[Y,I]=sort(thetam,2);

for i=1:l
prob2(i,:)=prob(i,I(i,:));
end

mean(Y,1)
std(Y,1)

mean(prob2,1)
std(prob2,1)

% Valeurs support VI boucle simple
thetam=zeros(12,4);
prob=zeros(12,4);
data=zeros(12,4,2);

for i=1:12
 
data=load(sprintf('VIsimpl_%d.out',i));

thetam(i,:)=data(:,1)';
prob(i,:)=data(:,2)';

end

[Y,I]=sort(thetam,2);

for i=1:12
prob2(i,:)=prob(i,I(i,:));
end

mean(Y,1)
std(Y,1)

mean(prob2,1)
std(prob2,1)

% Valeurs support bootstrap boucle simple
thetam=zeros(5,4);
prob=zeros(5,4);
data=zeros(5,4,2);

for i=1:1
 
data=load(sprintf('Bootstrapsimple_%d.out',i));

thetam(i,:)=squeeze(data(:,1))';
prob(i,:)=squeeze(data(:,2))';

end

[Y,I]=sort(thetam,2);

for i=1:1
prob2(i,:)=prob(i,I(i,:));
end

mean(Y,1)
std(Y,1)

mean(prob2,1)
std(prob2,1)

% Valeurs support bootstrap boucle gnrale
thetam=zeros(6,4);
prob=zeros(6,4);
data=zeros(6,4,2);

% nb de boostrap
l=19;

for i=1:l
 
data=load(sprintf('Bootstrap_%d.out',i));

thetam(i,:)=squeeze(data(:,1))';
prob(i,:)=squeeze(data(:,2))';

end

[Y,I]=sort(thetam,2);

for i=1:l
prob2(i,:)=prob(i,I(i,:));
end

mean(Y,1)
std(Y,1)

mean(prob2,1)
std(prob2,1)

% Coefficients boostrap boucle gnrale

for i=1:l
 
datam0(i,:)=load(sprintf('regm0_%d.out',i));
dataf0(i,:)=load(sprintf('regf0_%d.out',i));
datan1(i,:)=load(sprintf('regn1_%d.out',i));
datap1(i,:)=load(sprintf('regp1_%d.out',i));
%datan2(i,:)=load(sprintf('regn2_%d.out',i));
%datan2r(i,:)=load(sprintf('regn2r_%d.out',i));
datap2(i,:)=load(sprintf('regp2_%d.out',i));
datap2r(i,:)=load(sprintf('regp2r_%d.out',i));
%datan3(i,:)=load(sprintf('regn3_%d.out',i));
%datan3r(i,:)=load(sprintf('regn3r_%d.out',i));
datap3(i,:)=load(sprintf('regp3_%d.out',i));
datap3r(i,:)=load(sprintf('regp3r_%d.out',i));
datan4(i,:)=load(sprintf('regn4_%d.out',i));
datan4r(i,:)=load(sprintf('regn4r_%d.out',i));
datap4r(i,:)=load(sprintf('regp4r_%d.out',i));
datan5r(i,:)=load(sprintf('regn5r_%d.out',i));
datam9(i,:)=load(sprintf('regm9_%d.out',i));
datam9r(i,:)=load(sprintf('regm9r_%d.out',i));
dataf9(i,:)=load(sprintf('regf9_%d.out',i));
dataf9r(i,:)=load(sprintf('regf9r_%d.out',i));

end

meanest=mean([datam0 dataf0 datan1 datap1 datan2 datan2r datap2 datap2r datan3 datan3r datap3 datap3r datan4 datan4r datap4r datan5r datam9 datam9r dataf9 dataf9r ]);
stdest=std([datam0 dataf0 datan1 datap1 datan2 datan2r datap2 datap2r datan3 datan3r datap3 datap3r datan4 datan4r datap4r datan5r datam9 datam9r dataf9 dataf9r ]);

meanest=mean([datam0 dataf0 datan1 datap1 datap2 datap2r datap3 datap3r datan4 datan4r datap4r datan5r datam9 datam9r dataf9 dataf9r ]);
stdest=std([datam0 dataf0 datan1 datap1 datap2 datap2r datap3 datap3r datan4 datan4r datap4r datan5r datam9 datam9r dataf9 dataf9r ]);


X=[meanest ; stdest]

% Global Treatment effects
for i=1:l
importfile(sprintf('ATT_%d.out',i))
ATT(i,:)=data(:,3)';
importfile(sprintf('ATE_%d.out',i))
ATE(i,:)=data(:,3)';
end

ATTm=mean(ATT,1)
ATEm=mean(ATE,1)
ATTs=std(ATT,1)
ATEs=std(ATE,1)

% Decomposed Treatment Effects by groups
for i=1:l
importfile(sprintf('ATT2_%d.out',i))
ATT2math(i,:)=data(:,1)' ;
ATT2french(i,:)=data(:,2)' ;
%ATT22nde(i,:)=data(:,3)' ;
importfile(sprintf('ATE2_%d.out',i))
ATE2math(i,:)=data(:,1)' ;
ATE2french(i,:)=data(:,2)' ;
%ATE22nde(i,:)=data(:,3)' ;
end 

ATT2mathm=mean(ATT2math,1)
ATT2frenchm=mean(ATT2french,1)
ATT22ndem=mean(ATT22nde,1)

ATT2maths=std(ATT2math,1)
ATT2frenchs=std(ATT2french,1)
ATT22ndes=std(ATT22nde,1)

ATE2mathm=mean(ATE2math,1)
ATE2frenchm=mean(ATE2french,1)
ATE22ndem=mean(ATE22nde,1)

ATE2maths=std(ATE2math,1)
ATE2frenchs=std(ATE2french,1)
ATE22ndes=std(ATE22nde,1)
