

  /*************/
 /*  STEP 1   */
/*************/

gen repett=0

/*Math and French score before the entrance to grade 6 */
/*Prediction du capital humain*/

xi : reg mathel_std femme cspp3 dipm6 redoub_prim i.group_cat [pweight=prob_indiv]
predict resm0,res
gen resm02=prob_indiv*resm0^2
su resm02
scalar sigma_resm0=sqrt(r(mean))

xi : reg franel_std femme cspp3 dipm6 redoub_prim i.group_cat  [pweight=prob_indiv]
predict resf0,res
gen resf02=prob_indiv*resf0^2
su resf02
scalar sigma_resf0=sqrt(r(mean))


/*Size of class*/

xi : reg ned1 /*
*/  i.secteur1 ned1_th /*effectif_grade_1*/ femme cspp3 dipm6 redoub_prim eff_etab_t1 i.tuetab1 i.net1_tr lv11_all lv11_othe inzep1 /* 
*/ i.group_cat [pweight=prob_indiv]
predict resn1,res
gen resn12=prob_indiv*resn1^2
su resn12
scalar sigma_resn1=sqrt(r(mean))


  /***************/
 /*  STEP 2     */
/***************/

/*Probit de passage en 5me\4eme */
xi : oprobit pass1 ned1 i.quarter femme cspp3 dipm6 redoub_prim eff_etab_t1 i.secteur1 lv11_all inzep1 /*
*/ i.group_cat [pweight=prob_indiv] 
predict P1,outcome(1)

replace repett=1 if pass1==0

xi : reg ned2 /*
*/ i.secteur2 ned2_th /*effectif_grade_2*/ femme cspp3 dipm6 redoub_prim eff_etab_t2  i.tuetab2 lv12_all lv12_othe inzep2 /* 
*/ i.group_cat   [pweight=prob_indiv] if repett==0
predict resn2,res
gen resn22=prob_indiv*resn2^2
su resn22  if repett==0
scalar sigma_resn2=sqrt(r(mean))

xi : reg ned2 i.secteur2 ned2_th /*effectif_grade_2*/ femme cspp3 dipm6 redoub_prim eff_etab_t2 net2_tr3  tuetab28 tuetab29 lv12_all inzep2 /* 
*/ i.group_cat  [pweight=prob_indiv] if repett==1
predict resn2r,res
gen resn22r=prob_indiv*resn2r^2
su resn22r  if repett==1
scalar sigma_resn2r=sqrt(r(mean))
  /***************/
 /*  STEP 3     */
/***************/

/*Probit de passage en 4me/5me */

xi : oprobit pass2 ned2 i.quarter femme cspp3 dipm6 redoub_prim tuetab28 tuetab29 net2_tr3 lv12_all inzep2 /* 
*/ i.group_cat   [pweight=prob_indiv] if pass1==1
predict P20 P21 P22

xi : oprobit pass2 ned2 i.quarter femme cspp3 dipm6 redoub_prim tuetab23 tuetab26 tuetab27 tuetab29 net2_tr3  /* 
*/ i.group_cat [pweight=prob_indiv] if repett==1
predict P2r if repett==1,outcome(2)

replace repett=1 if pass2==1
replace repett=. if pass2==0

xi : reg ned3 ned3_th  femme cspp3 dipm6 redoub_prim secteur3 eff_etab_t3 tuetab32-tuetab39 net3_tr2 lv13_all inzep3 /* 
*/ i.group_cat  [pweight=prob_indiv] if repett==0
predict resn3,res
gen resn32=prob_indiv*resn3^2
su resn32 if repett==0
scalar sigma_resn3=sqrt(r(mean))

xi : reg ned3 ned3_th  femme cspp3 dipm6 redoub_prim secteur3 eff_etab_t3 tuetab33 tuetab39 net3_tr3 lv13_all inzep3 /* 
*/ i.group_cat  [pweight=prob_indiv] if repett==1
predict resn3r,res
gen resn32r=prob_indiv*resn3r^2
su resn32r if repett==1
scalar sigma_resn3r=sqrt(r(mean))


  /***************/
 /*  STEP 4     */
/***************/

/*Probit de passage en 3me/4me */

xi : oprobit pass3 ned3 i.quarter femme cspp3 dipm6 redoub_prim eff_etab_t3 tuetab33 tuetab34 net3_tr3 lv13_all  /* 
*/ i.group_cat   [pweight=prob_indiv] if repett==0
predict P30 P31 P32 if repett==0

xi : oprobit pass3 ned3 i.quarter femme cspp3 dipm6 redoub_prim tuetab39 net3_tr2-net3_tr3 lv13_all   /* 
*/ i.group_cat  [pweight=prob_indiv] if repett==1
predict P3r if repett==1,outcome(2)

replace repett=1 if pass3==1
replace repett=. if pass3==0

xi : reg ned4 ned4_th femme cspp3 dipm6 redoub_prim secteur4 eff_etab_t4 tuetab43-tuetab49 lv14_all inzep4 /* 
*/  i.group_cat  [pweight=prob_indiv]  if repett==0
predict resn4,res
gen resn42=prob_indiv*resn4^2
su resn42 if repett==0
scalar sigma_resn4=sqrt(r(mean))

xi : reg ned4 ned4_th femme cspp3 dipm6 redoub_prim secteur4  eff_etab_t4 tuetab42-tuetab44 tuetab46 tuetab48-tuetab49 lv14_all inzep4 /* 
*/  i.group_cat  [pweight=prob_indiv]  if repett==1
predict resn4r,res
gen resn42r=prob_indiv*resn4r^2
su resn42r if repett==1
scalar sigma_resn4r=sqrt(r(mean))


  /***************/
 /*  STEP 5     */
/***************/

/*Probit de passage en 3me pour les redoublants */

xi : oprobit pass4 i.quarter ned4 femme cspp3 dipm6 redoub_prim secteur4 tuetab43 tuetab44 tuetab46 tuetab48 tuetab49  /* 
*/ i.group_cat  [pweight=prob_indiv] if repett==1
predict P4 if repett==1 ,outcome(1)

xi : reg ned5 ned5_th femme cspp3 dipm6 redoub_prim eff_etab_t5 tuetab52 tuetab56-tuetab59 net5_tr4 lv15_all inzep5 /* 
*/ i.group_cat [pweight=prob_indiv] if repet==1
predict resn5,res
gen resn52=prob_indiv*resn5^2
su resn52 if repet==1
scalar sigma_resn5=sqrt(r(mean))


  /*************/
 /*  STEP 9   */
/*************/


xi : reg grade9_mat_std ned4 femme cspp3 dipm6 redoub_prim secteur4 tuetab45 tuetab47 net4_tr4 lv14_all inzep4 /* 
*/  i.group_cat  [pweight=prob_indiv] if repet==0
predict resbrevm_pass,res
gen resbrevm_pass2=prob_indiv*resbrevm_pass^2
su resbrevm_pass2 if repet==0
scalar sigma_resbrevm_pass=sqrt(r(mean))


xi : reg grade9_fra_std ned4 femme cspp3 dipm6 redoub_prim tuetab46 lv14_all inzep4 /* 
*/ i.group_cat  [pweight=prob_indiv] if repet==0
predict resbrevf_pass,res
gen resbrevf_pass2=prob_indiv*resbrevf_pass^2
su resbrevf_pass2 if repet==0
scalar sigma_resbrevf_pass=sqrt(r(mean))

/* Student who did a retention but are in the general field */

* il faut rajouter les x en 5 et enlever ceux en 4.... 
xi : reg grade9_mat_std ned5 femme cspp3 dipm6 redoub_prim secteur5 tuetab57 tuetab59 net5_tr4 i.group_cat  [pweight=prob_indiv] if repet==1
predict resbrevm_passpas,res
gen resbrevm_passpas2=prob_indiv*resbrevm_passpas^2
su resbrevm_passpas2 if repet==1
scalar sigma_resbrevm_passpas=sqrt(r(mean))


xi : reg grade9_fra_std ned5 femme cspp3 dipm6 redoub_prim secteur5 tuetab54  /* 
*/ i.group_cat  [pweight=prob_indiv] if repet==1
predict resbrevf_passpas,res
gen resbrevf_passpas2=prob_indiv*resbrevf_passpas^2
su resbrevf_passpas2 if repet==1
scalar sigma_resbrevf_passpas=sqrt(r(mean))

recode resbrevm_passpas .=1
recode resbrevm_pass .=1
recode resbrevf_passpas .=1
recode resbrevf_pass .=1
recode resn2 .=1
recode resn2r .=1
recode resn3 .=1
recode resn3r .=1
recode resn4 .=1
recode resn4r .=1
recode resn5 .=1
recode P30 .=1
recode P31 .=1
recode P32 .=1
recode P3r .=1
recode P2r .=1
recode P4 .=1
/*
recode P2nde .=1
recode P2nder .=1
*/



