set more off
local crit=1
local iter=1
local llk=0

di "Program started on $S_DATE at $S_TIME" 
while `iter'<1000 & `crit'>0.00001 {

quietly{

run Model5s.do 
*Model55 qui utilise les probindiv2

gen vrais_indiv=normalden(resm0,0,sigma_resm0)*normalden(resf0,0,sigma_resf0)


/* Build the individual weight */

gen weight_vrais=prob2*vrais_indiv
bysort ident : egen weight_sum=total(weight_vrais)

gen weight_indiv_prim=prob2*vrais_indiv/weight_sum

/* New type weights using constraints */

bysort group_cat : egen prob_prim=mean(weight_indiv_prim)


/*Calcul de la vraisemblance totale*/
gen a=log(weight_sum)

egen vrais=total(a) 
su vrais
local llk=r(mean)

gen diff= (prob2-prob_prim)^2 

egen diff_sum_square=sum(diff)

sum diff_sum_square

local crit=r(mean)
local iter=`iter'+1

/* Actualisation of weight */

drop prob2 prob_indiv2 
rename prob_prim prob2
rename weight_indiv_prim prob_indiv2

drop resm0 resf0 resm02 resf02 resn1 resn12 resn22 resn2 resn3 resn32 resn4 resn42 resn5 resn52 /*
*/ resn22r resn2r resn3r resn32r resn4r resn42r resn5 resn52 P1 P4 P20 P21 P22 P30 P31 P32 P2r P3r  /*
*/ resbrevm_pass resbrevm_passpas resbrevf_pass resbrevf_passpas resbrevm_pass2 resbrevm_passpas2 resbrevf_pass2 resbrevf_passpas2  /*
*/ vrais_indiv weight_sum weight_vrais diff diff_sum_square repett vrais a
}

if mod(`iter',5)==0 {

di "Nb d'iterations =" `iter'

di "Heure : $S_TIME" 

di "crit ="  `crit'

di "Loglikelihood=" `llk'

}
}


/* After convergence : results interpretation */
